# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class IoK8sApimachineryPkgApisMetaV1ListMeta(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, _continue: str=None, remaining_item_count: int=None, resource_version: str=None, self_link: str=None):  # noqa: E501
        """IoK8sApimachineryPkgApisMetaV1ListMeta - a model defined in Swagger

        :param _continue: The _continue of this IoK8sApimachineryPkgApisMetaV1ListMeta.  # noqa: E501
        :type _continue: str
        :param remaining_item_count: The remaining_item_count of this IoK8sApimachineryPkgApisMetaV1ListMeta.  # noqa: E501
        :type remaining_item_count: int
        :param resource_version: The resource_version of this IoK8sApimachineryPkgApisMetaV1ListMeta.  # noqa: E501
        :type resource_version: str
        :param self_link: The self_link of this IoK8sApimachineryPkgApisMetaV1ListMeta.  # noqa: E501
        :type self_link: str
        """
        self.swagger_types = {
            '_continue': str,
            'remaining_item_count': int,
            'resource_version': str,
            'self_link': str
        }

        self.attribute_map = {
            '_continue': 'continue',
            'remaining_item_count': 'remainingItemCount',
            'resource_version': 'resourceVersion',
            'self_link': 'selfLink'
        }
        self.__continue = _continue
        self._remaining_item_count = remaining_item_count
        self._resource_version = resource_version
        self._self_link = self_link

    @classmethod
    def from_dict(cls, dikt) -> 'IoK8sApimachineryPkgApisMetaV1ListMeta':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta of this IoK8sApimachineryPkgApisMetaV1ListMeta.  # noqa: E501
        :rtype: IoK8sApimachineryPkgApisMetaV1ListMeta
        """
        return util.deserialize_model(dikt, cls)

    @property
    def _continue(self) -> str:
        """Gets the _continue of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a consistent list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response, unless you have received this token from an error message.  # noqa: E501

        :return: The _continue of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :rtype: str
        """
        return self.__continue

    @_continue.setter
    def _continue(self, _continue: str):
        """Sets the _continue of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a consistent list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response, unless you have received this token from an error message.  # noqa: E501

        :param _continue: The _continue of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :type _continue: str
        """

        self.__continue = _continue

    @property
    def remaining_item_count(self) -> int:
        """Gets the remaining_item_count of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        remainingItemCount is the number of subsequent items in the list which are not included in this list response. If the list request contained label or field selectors, then the number of remaining items is unknown and the field will be left unset and omitted during serialization. If the list is complete (either because it is not chunking or because this is the last chunk), then there are no more remaining items and this field will be left unset and omitted during serialization. Servers older than v1.15 do not set this field. The intended use of the remainingItemCount is *estimating* the size of a collection. Clients should not rely on the remainingItemCount to be set or to be exact.  # noqa: E501

        :return: The remaining_item_count of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :rtype: int
        """
        return self._remaining_item_count

    @remaining_item_count.setter
    def remaining_item_count(self, remaining_item_count: int):
        """Sets the remaining_item_count of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        remainingItemCount is the number of subsequent items in the list which are not included in this list response. If the list request contained label or field selectors, then the number of remaining items is unknown and the field will be left unset and omitted during serialization. If the list is complete (either because it is not chunking or because this is the last chunk), then there are no more remaining items and this field will be left unset and omitted during serialization. Servers older than v1.15 do not set this field. The intended use of the remainingItemCount is *estimating* the size of a collection. Clients should not rely on the remainingItemCount to be set or to be exact.  # noqa: E501

        :param remaining_item_count: The remaining_item_count of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :type remaining_item_count: int
        """

        self._remaining_item_count = remaining_item_count

    @property
    def resource_version(self) -> str:
        """Gets the resource_version of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency  # noqa: E501

        :return: The resource_version of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :rtype: str
        """
        return self._resource_version

    @resource_version.setter
    def resource_version(self, resource_version: str):
        """Sets the resource_version of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency  # noqa: E501

        :param resource_version: The resource_version of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :type resource_version: str
        """

        self._resource_version = resource_version

    @property
    def self_link(self) -> str:
        """Gets the self_link of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        selfLink is a URL representing this object. Populated by the system. Read-only.  DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release.  # noqa: E501

        :return: The self_link of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :rtype: str
        """
        return self._self_link

    @self_link.setter
    def self_link(self, self_link: str):
        """Sets the self_link of this IoK8sApimachineryPkgApisMetaV1ListMeta.

        selfLink is a URL representing this object. Populated by the system. Read-only.  DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release.  # noqa: E501

        :param self_link: The self_link of this IoK8sApimachineryPkgApisMetaV1ListMeta.
        :type self_link: str
        """

        self._self_link = self_link
